package characters;

// eventually, the Sword class is abstract - it's something like interface, but can have (non-static) attributes
public abstract class Sword {
	private int productNumber;

	public Sword(int productNumber) {
		this.productNumber = productNumber;
	}
	
	public int getProductNumber() {
		return productNumber;
	}
	public void setProductNumber(int productNumber) {
		this.productNumber = productNumber;
	}
	
	// we need a hit method for each kind of knight
//	public abstract void hitKnight(Ogre ogre, BraveKnight knight) {
//	public abstract void hitBraveKnight(Ogre ogre, BraveKnight knight) {

	// however, we can use overloading to avoid having to invent method names
	// the compiler makes the decision which method is to be run according to the type of the knight parameter
	public abstract void hit(Ogre ogre, Knight knight);
	public abstract void hit(Ogre ogre, BraveKnight knight);
}
