package clash;

import characters.*;
import java.util.*;

public class Clash {

	public Knight knight[];
	public Ogre ogre[];
	
	public int numberOfWarriors;
	
	private ArrayList<ClashFollower> clashFollowers = new ArrayList<>();
	
	public Clash(int knights, int braveKnights, int badOgres) {
		numberOfWarriors = knights + braveKnights;
		knight = new Knight[numberOfWarriors];
		ogre = new Ogre[numberOfWarriors];

		for (int i = 0; i < knights; ++i){
			knight[i] = new Knight(80);
		}

		for (int i = knights; i < numberOfWarriors; ++i){
			knight[i] = new BraveKnight(100);
		}

		for (int i = 0; i < badOgres; ++i){
			ogre[i] = new BadOgre(100);
		}
		
		for (int i = badOgres; i < numberOfWarriors; ++i){
			ogre[i] = new Ogre(100);
		}
		
		informClashFollowers();
	}
	
	public String clash1on1(Knight knight, Ogre ogre) {
		knight.attack(ogre);
		
		informClashFollowers();
		
		return(knight + " / " + ogre);
	}
	
	public String clash() {
		String report = "";

		for (int i = 0; i < numberOfWarriors; ++i)
			report = report + clash1on1(knight[i], ogre[i]) + "\n";
	
		return report;
	}
	
	public void followClash(ClashFollower clashFollower) {
		clashFollowers.add(clashFollower);
	}
	
	public void informClashFollowers() {
		for (ClashFollower clashFollower : clashFollowers)
			clashFollower.inform();
	}	
	
	public static void main(String[] args) {
		Clash clash = new Clash(7, 3, 5);
		
		clash.followClash(new ClashWinners(clash));
		clash.followClash(new ClashWinners(clash));
		clash.followClash(new ClashReport(clash));
		
		System.out.println(clash.clash());
	}
}
